<?php

namespace DeubertIt\Healthchecks;

use Composer\Composer;
use Composer\Script\Event;
use Composer\EventDispatcher\EventSubscriberInterface;
use Composer\IO\IOInterface;
use Composer\Plugin\PluginInterface;
use Composer\Installer\PackageEvent;
use Composer\Package\PackageInterface;

class Healthchecks implements PluginInterface, EventSubscriberInterface
{
    const PACKAGE_NAME = 'deubertit/composer-healthchecks';

    const EXTRA_PUBLIC_PATH = 'dit-healthchecks-public-path';

    /**
     * @var IOInterface
     */
    protected $_io;

    /**
     * @var string
     */
    protected $_publicPath;

    /**
     * @return  array       Callbacks list for composer events
     */
    public static function getSubscribedEvents()
    {
        return [
            'post-package-install' => [
                ['onPackageAction', 0]
            ],
            'post-package-update' => [
                ['onPackageAction', 0]
            ],
        ];
    }

    /**
     * @param   Composer            $composer
     * @param   IOInterface         $io
     */
    public function activate(Composer $composer, IOInterface $io)
    {
        $this->_io = $io;

        $extra = $composer->getPackage()->getExtra();

        if (!isset($extra[self::EXTRA_PUBLIC_PATH]) 
            || empty($extra[self::EXTRA_PUBLIC_PATH]))
        {
            $this->_io->writeError('extra.' . self::EXTRA_PUBLIC_PATH . ' value is mandatory');
        }

        $this->_publicPath = __DIR__ . '/' . $extra[self::EXTRA_PUBLIC_PATH];
    }

    /**
     * @param  PackageEvent         $event
     */
    public function onPackageAction(PackageEvent $event)
    {
        $package = $event->getOperation()->getPackage();

        if ($package->getName() !== self::PACKAGE_NAME)
        {
            return;
        }

        //

        //$this->_io->writeError( $e->getMessage() );
        $this->_ io->write('healthckecks script successfully installed to ' . $this->_publicPath);
    }
}

